#define KEY_PAD_PORT P1
sbit R1=KEY_PAD_PORT^0;
sbit R2=KEY_PAD_PORT^1;
sbit R3=KEY_PAD_PORT^2;
sbit R4=KEY_PAD_PORT^3;

sbit C1=KEY_PAD_PORT^6;
sbit C2=KEY_PAD_PORT^5;
sbit C3=KEY_PAD_PORT^4;

unsigned char key_char[13]=" 123456789*0#";

unsigned char read_sw(unsigned char c){
unsigned char key=0;	
	if(C1==0)key=c+1;
	else if(C2==0)key=c+2;
	else if(C3==0)key=c+3;

return key;
}

unsigned char scan_key(){
unsigned char c=0,key=0;
	R1=0;R2=1;R3=1;R4=1;
	key=read_sw(c);
	if(!key){
	c+=3;
	R1=1;R2=0;R3=1;R4=1;
	key=read_sw(c);
	}
	if(!key){
	c+=3;
	R1=1;R2=1;R3=0;R4=1;
	key=read_sw(c);
	}
	if(!key){
	c+=3;
	R1=1;R2=1;R3=1;R4=0;
	key=read_sw(c);
	}
return key;
}

unsigned char get_keypad(){
return key_char[scan_key()];
}